#!/bin/python
# -*- coding: utf-8 -*-

import sys
import re
import os

config = {}
config['debug'] = 1
config['keyword'] = '关键字'
config['vname'] = 'keyword'

def log( _str ):
    if ( not config['debug'] ):
        return
    print _str

def replace_keyword(line):
    '替换一行文件中的关键字'
    rt = []
    pos = [0]
    def get_str(fd, dd):
        nd = 0
        p = pos[0]
        _p = p + fd
        while 1:
            _p = _p + nd + 1
            _str = line[_p:]
            nd = _str.find(dd)
            #找不到字符串结尾,返回
            if ( nd == -1 ):
                break
            #如果字符串为属性名,跳过
            if ( re.match('[ \t]*:.*', _str[nd + 1:]) is not None ):
                p = _p + nd + 1
                pos[0] = p
                break
            #找到字符串结尾,返回,并更新pos
            if ( nd == 0 or _str[nd - 1] != '\\'):
                _t = line[p + fd:_p + nd + 1]
                rt.append(_t)
                p = _p + nd + 1 
                pos[0] = p
                break
            else:
            #如果引号前面有转义符,继续寻找字符串结尾
                continue
    while 1:
        
        fd = line[pos[0]:].find('\'')
        fdd = line[pos[0]:].find('"')
        
        #如果没有单引号也没有双引号,跳出循环,不要处理
        if (fd == -1 and fdd == -1):
            break
        #如果既有单引号又有双引号
        if (fd != -1 and fdd != -1):
            if (fd < fdd):
                #分析靠前的单引号打头字符串
                get_str(fd, '\'')
            else:
                #分析双引号打头字符串
                get_str(fdd, '"')
        #只有单引号
        elif (fd != -1 and fdd == -1):
            get_str(fd, '\'')
        #只有双引号
        else:
            get_str(fdd, '"')

        
    
    keyword = config['keyword']
    vname = config['vname']

    for str in rt:
        if (str.find(keyword) != -1):
            d = str[0]
            line = line.replace(str, str.replace(keyword, d + ' + ' + vname + ' + ' + d))
    return line
    
def replace_stdfile(f):
    '替换标准文件，并输出到标准输出'
    while 1:
        line = f.readline();
        if ( not line ):
            break
        #将\符号连接的行连接为一行,以便逐行替换
        while ( line.endswith("\\") ):
            line = line.replace("\\\n",'#join#') + f.readline()
        if (line.find(config['keyword']) != -1):
            rt = replace_keyword(line)
        else:
            rt = line
        print rt.replace('#join#', '\\\n'),

def replace_stdin():
    '替换标准输入'
    replace_stdfile(sys.stdin)

def replace_file(file):
    '替换指定的文件'
    if ( not os.path.isfile( file ) ):
        return
    f = open( file, 'r' )
    replace_stdfile(f) 
    f.close()

def main():
    if ( len(sys.argv) < 2 ):
        return
    if ( sys.argv[1] == '--stdin' ):
        replace_stdin()
    else:
        replace_file(sys.argv[1])

if ( __name__ == '__main__' ):
    main()
